/*
 * Copyright (c) 2019 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef BUNDLE_CPP_IMPLEMENTATION_H_
#define BUNDLE_CPP_IMPLEMENTATION_H_

#include <string>
#include <memory>
#include <list>

#include "bundle_cpp.h"

namespace tizen_base {

class Bundle::KeyInfo::Impl {
 public:
  virtual ~Impl();

 private:
  Impl(Bundle::KeyInfo* parent, const bundle_keyval_t* handle,
       std::string name);
  explicit Impl(Bundle::KeyInfo* parent);

 private:
  friend class Bundle::KeyInfo;

 private:
  const bundle_keyval_t* handle_;
  std::string name_;
  Bundle::KeyInfo* parent_;
};

class Bundle::Impl {
 public:
  virtual ~Impl();

 private:
  explicit Impl(Bundle* parent);
  Impl(Bundle* parent, bool copy, bool own);

 private:
  friend class Bundle;

  bundle* handle_ = nullptr;
  bool copy_ = true;
  bool own_ = true;
  Bundle* parent_ = nullptr;
};

}  // namespace tizen_base

#endif  // BUNDLE_CPP_IMPLEMENTATION_H_
